#include "HAL_conf.h"
#include "timer.h"
#include "stdio.h"

//TIM2-CH4
//PD8
void TIM2_GPIO_Config(void)
{        
	GPIO_InitTypeDef  GPIO_InitStructure;        
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM2, ENABLE);         
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOD, ENABLE);            
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;         
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; //        
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;       
  GPIO_Init(GPIOD,&GPIO_InitStructure);  
	
	//
	GPIO_PinAFConfig(GPIOD, GPIO_Pin_8, GPIO_AF_TIM_1_2); //PD8ΪPWM
}

void TIM2_Mode_Config(u16 arr,u16 psc)
{              
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;              
	TIM_OCInitTypeDef  TIM_OCInitStructure;  
  TIM2_GPIO_Config();	   
  TIM2->CCR4 = 0;	
	TIM_TimeBaseStructure.TIM_Period = arr;  //ʱ0999Ϊ1000ΣΪһʱ       
	TIM_TimeBaseStructure.TIM_Prescaler = psc;
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //ϼģʽ    
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1 ; //ʱӷƵϵƵ                 
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
	
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2; //ΪPWMģʽ2                           
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;  //ʱֵСCCR1_ValʱΪߵƽ
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;  
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable; 	
	TIM_OC4Init(TIM2, &TIM_OCInitStructure); //ʹͨ4  
	TIM_OC4PreloadConfig(TIM2, TIM_OCPreload_Enable);    
	
	TIM_ARRPreloadConfig(TIM2, ENABLE);  // ʹTIM2ؼĴARR    	
	TIM_CtrlPWMOutputs(TIM2,ENABLE); 	
	TIM_Cmd(TIM2,ENABLE);  

//	TIM2->DIER |= 1<<4; //Ƚж
//	NVIC_SetPriority(TIM2_CC_IRQn,3);
//	NVIC_EnableIRQ(TIM2_CC_IRQn);
} 





void Times_Pwm_Config(u16 psc,u16 arr,u16 ccr)
{

	TIM2_GPIO_Config();

	TIM2->CNT = 0;
	TIM2->ARR = arr;
	TIM2->PSC = psc;
	TIM2->CCR4 = ccr;
	TIM2->CR1 = 0;
//	TIM2->CR1 |= 1<<7; //޻幦
  TIM2->CCMR2 = 0;
	TIM2->CCMR2 |= (0x7<<12);
	TIM2->CCMR2 |= (0x1<<11);
	TIM2->CCER = 0;
	TIM2->CCER |= 1<<12; //ʹͨ4
	TIM2->BDTR |=1<<15; //ʹ
	TIM2->EGR |= 1<<4; //Ƚ4¼
	TIM2->EGR |= 1<<0; //ж
	TIM2->CR1 |= 1<<0; //ʹܼ
  TIM2->DIER |= 1<<4; //Ƚж
	TIM2->DIER |= 1<<0; //ж
	
	NVIC_SetPriority(TIM2_UP_IRQn,3);
	NVIC_EnableIRQ(TIM2_UP_IRQn);
}

void TIM2_CC_IRQHandler(void)
{
  if((TIM2->SR & (1<<4)) == 1) //жϱ־
	{
	}
	TIM2->SR &=~(1<<4);
}
int i = 0;
int flag = 0;
void TIM2_UP_IRQHandler(void)
{
  if((TIM2->SR & (1<<0)) == 1)
	{
    if(!flag)
	  {
			i++;
			if(i == 499)
			flag = 1;
		}
		else 
		{
			i--;
		  if(i == 0)
			flag = 0;
		}
	}
	TIM2->CCR4 = i;
	TIM2->SR &=~(1<<0);
}







